<?php

namespace Drupal\flex_processor\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines a  Entity Processor item annotation object.
 *
 * @see \Drupal\flex_processor\Plugin\DataProcessor
 * @see plugin_api
 *
 * @Annotation
 */
class DataProcessor extends Plugin {

  /**
   * The plugin ID.
   *
   * @var string
   */
  public $id;

  /**
   * The label of the plugin.
   *
   * @var \Drupal\Core\Annotation\Translation
   *
   * @ingroup plugin_translatable
   */
  public $label;

  /**
   * The type of entity.
   *
   * @var string
   */
  public $type;

  /**
   * The bundle of entity.
   *
   * @var string[]
   */
  public $bundles = [];

  /**
   * The view_mode of entity.
   *
   * @var string
   */
  public $variant = "default";

}
