<?php

namespace Drupal\flex_processor\Plugin;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Plugin\PluginBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Base class for DataProcessorBase plugin plugins.
 */
abstract class DataProcessorBase extends PluginBase implements DataProcessorInterface, ContainerFactoryPluginInterface {

  /**
   * The Entity processor manager.
   *
   * @var \Drupal\flex_processor\Plugin\DataProcessorManager
   */
  protected $dataProcessorManager;

  public function __construct(
    array $configuration,
    $plugin_id,
    $plugin_definition,
    DataProcessorManager $dataProcessorManager,
  ) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->dataProcessorManager = $dataProcessorManager;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $container->get('plugin.manager.flex_processor'),
    );
  }

  /**
   * {@inheritdoc}
   */
  public function preProcess(mixed $component, array $options = []) : mixed {
    return $this->process($component, $options);
  }

  /**
   * {@inheritdoc}
   */
  abstract public function process(mixed $component, array $options = []) : mixed;

}
