<?php

namespace Drupal\flex_processor\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;

/**
 * Defines an interface for a data Processor plugin.
 */
interface DataProcessorInterface extends PluginInspectionInterface {

  /**
   * Pre-process a data component.
   *
   * @param mixed $component
   *   The data component.
   * @param array<string, mixed> $options
   *   The options set to process the components.
   */
  public function preProcess(mixed $component, array $options = []): mixed;

  /**
   * Runs the data processing on the given component.
   *
   * @param mixed $component
   *   The data component.
   * @param array<string, mixed> $options
   *   The options set to process the components.
   */
  public function process(mixed $component, array $options = []): mixed;

}
