<?php

namespace Drupal\flex_processor\Plugin;

use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Base class for FieldDataProcessor plugin.
 */
abstract class EntityDataProcessor extends DataProcessorBase {

  /**
   * The entity repository service.
   *
   * @var \Drupal\Core\Entity\EntityRepositoryInterface
   */
  protected $entityRepository;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    $instance = parent::create(
      $container,
      $configuration,
      $plugin_id,
      $plugin_definition,
    );

    $instance->entityRepository = $container->get('entity.repository');

    return $instance;
  }

  /**
   * {@inheritdoc}
   */
  public function preProcess(mixed $component, array $options = []): mixed {

    $entity = $this->entityRepository->getTranslationFromContext($component, $options['langcode']);
    return $this->process($entity, $options);
  }

}
