<?php

namespace Drupal\flex_processor\Plugin;

use Drupal\Core\Field\FieldItemInterface;

/**
 * Base class for FieldDataProcessor plugin.
 */
abstract class FieldDataProcessor extends DataProcessorBase {

  /**
   * {@inheritdoc}
   */
  public function preProcess(mixed $fields, array $options = []): mixed {
    $single = FALSE;
    $multiple = FALSE;
    if (isset($options['multiple']) && $options['multiple']) {
      $multiple = TRUE;
    }
    $count = $fields->count();
    $data = [];

    if ($count == 0) {
      return '';
    }

    // We want to handle both field item list as individual field items.
    if ($fields instanceof FieldItemInterface) {
      $fields = [$fields];
      $single = TRUE;
    }
    else {
      if ($count == 1) {
        $single = TRUE;
      }
    }

    foreach ($fields as $field) {
      if (!$field->isEmpty()) {
        $data[] = $this->process($field, $options);
      }
    }

    return $single && !$multiple ? reset($data) : $data;
  }

}
