<?php

namespace Drupal\flex_processor\Plugin\FieldDataProcessors;

use Drupal\flex_processor\Plugin\FieldDataProcessor;

/**
 * Returns the (structured) data of a field.
 *
 * @DataProcessor(
 *   id = "field_entity_reference",
 *   label = @Translation("Entity reference"),
 *   type = "field",
 *   bundles = {
 *     "entity_reference",
 *     "entity_reference_revisions"
 *   }
 * )
 */
class FieldEntityReference extends FieldDataProcessor {

  /**
   * {@inheritdoc}
   */
  public function process(mixed $field, array $options = []): mixed {

    $entity = $field->get('entity')->getValue();
    if ($entity) {
      return $this->dataProcessorManager->process($entity, $options);
    }

    return NULL;
  }

}
