<?php

namespace Drupal\flex_processor\Plugin\FieldDataProcessors;

use Drupal\flex_processor\Plugin\FieldDataProcessor;

/**
 * Returns the (structured) data of a field.
 *
 * @DataProcessor(
 *   id = "field_formatted_text",
 *   label = @Translation("Formatted text"),
 *   type = "field",
 *   bundles = {
 *     "text",
 *     "text_long",
 *     "text_with_summary"
 *   }
 * )
 */
class FieldFormattedText extends FieldDataProcessor {

  /**
   * {@inheritdoc}
   */
  public function process(mixed $field, array $options = []): mixed {
    return check_markup($field->value, $field->format);
  }

}
