<?php

namespace Drupal\flex_processor\Plugin\FieldDataProcessors;

use Drupal\flex_processor\Plugin\FieldDataProcessor;

/**
 * Returns the (structured) data of a field.
 *
 * @DataProcessor(
 *   id = "field_list",
 *   label = @Translation("List"),
 *   type = "field",
 *   bundles = {
 *     "list_integer",
 *     "list_float",
 *     "list_string"
 *   }
 * )
 */
class FieldList extends FieldDataProcessor {

  /**
   * {@inheritdoc}
   */
  public function process(mixed $field, array $options = []): mixed {
    $data = $field->value;

    if (!empty($options['format']) && $options['format'] == 'value') {
      $allowed_values = $field->getDataDefinition()->getSetting('allowed_values');
      $data = $allowed_values[$field->value];
    }

    return $data;
  }

}
