<?php

namespace Drupal\flex_processor\Plugin\FieldDataProcessors;

use Drupal\flex_processor\Plugin\FieldDataProcessor;

/**
 * Returns the (structured) data of a field.
 *
 * @DataProcessor(
 *   id = "field_plain_text",
 *   label = @Translation("Plain text"),
 *   type = "field",
 *   bundles = {
 *     "string",
 *     "string_long",
 *     "integer",
 *     "email"
 *   }
 * )
 */
class FieldPlainText extends FieldDataProcessor {

  /**
   * {@inheritdoc}
   */
  public function process(mixed $field, array $options = []): mixed {
    return $field->value;
  }

}
